//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  PowerShell eXgpvO
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N1112 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plRedirectForPSUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, NkClipDetector, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Splitter1: TSplitter;
    Memo2: TMemo;
    Button2: TButton;
    NkClipDetector1: TNkClipDetector;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure NkClipDetector1ClipChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    FPSExeFullPath :string;
    FhPSWnd : HWND;
    FInitDir : string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  plCommandRedirect,
  Clipbrd,
  ShellAPI;

{$R *.dfm}

const
  FWndClassName = 'ConsoleWindowClass';

function AttachConsole(dwProcess: DWORD): BOOL; stdcall; external 'kernel32.dll';

//-----------------------------------------------------------------------------
//  W͂ɃL[͂
//-----------------------------------------------------------------------------
procedure SendCommandPrompt(AText: string);
var
  LhStdInput : THandle;
  LInputRec  : TInputRecord;
  LEventNum  : DWORD;
  i          : Integer;
begin
  //W͂̃nh擾
  LhStdInput := GetStdHandle(STD_INPUT_HANDLE);

  AText := AText + Chr(VK_RETURN);
  //DelphiString^͍ŏ̕vfԍ1
  for i := 1  To Length(AText) do begin
    FillChar(LInputRec, SizeOf(LInputRec), #0);
    LInputRec.EventType := KEY_EVENT;
    LInputRec.Event.KeyEvent.wRepeatCount := 1;
    LInputRec.Event.KeyEvent.UnicodeChar  := AText[i];
    LInputRec.Event.KeyEvent.bKeyDown     := True;
    WriteConsoleInput(LhStdInput, LInputRec, 1, LEventNum );
  end;
end;

//-----------------------------------------------------------------------------
//  EBhEnhEBhENX擾
//-----------------------------------------------------------------------------
function GetClassNameStr(hWindow: HWND): string;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  FillChar(Buffer, SizeOf(Buffer), #0);
  Len := GetClassName(hWindow, Buffer, Length(Buffer));
  if Len > 0 then Result := Buffer else Result := '';
end;

//-----------------------------------------------------------------------------
//  EnumWindows̃R[obN֐
//  EBhEnh擾p
//-----------------------------------------------------------------------------
function EnumWindowsHandleProc(hWindow: hWnd; lPar: PNativeInt):
  Boolean; Stdcall;
var
  LWndClass : string;
  LhCmdWnd  : HWND;
begin
  Result   := True;
  LhCmdWnd := LPar^;

  if IsWindowVisible(hWindow) then begin
    //EBhẼNX
    LWndClass := GetClassNameStr(hWindow);
    if LWndClass = FWndClassName then begin
      //܂NĂȂꍇ
      if LhCmdWnd = 0 then begin
        lPar^ := hWindow;
        Result := False;
      end else begin
        //N̏ꍇ͕ďI
        if LhCmdWnd = hWindow then begin
          SendMessage(hWindow, WM_CLOSE, 0, 0);
          Result := False;
        end;
      end;
    end;
  end;
end;

//=============================================================================
//  tH[\Jn̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LExeFullPath : string;
begin
  Caption := 'PowerShell eXgp';

  //PowerShell.exẽtpX擾
  FPSExeFullPath := '"' + SysUtils.GetEnvironmentVariable('Systemroot')
                  + '\System32\WindowsPowerShell\v1.0\powershell.exe"';

  LExeFullPath := SysUtils.AnsiDequotedStr(FPSExeFullPath, '"');
  if not FileExists(LExeFullPath) then FPSExeFullPath := '';


  Edit1.Font.Charset := ANSI_CHARSET;
  Edit1.Font.Name    := 'Courier New';
  Edit1.Font.Size    := 10;

  Memo1.Font.Charset := DEFAULT_CHARSET;
  Memo1.Font.Name    := 'lr SVbN';
  Memo1.Font.Size    := 10;

  Memo2.Font.Charset := DEFAULT_CHARSET;
  Memo2.Font.Name    := 'lr SVbN';
  Memo2.Font.Size    := 10;

  //XNvgt@C̕ۑ
  Edit1.Text := '000.ps1';

  //sPowerShell̃XNvg
  Memo1.Lines.Clear;
  Memo1.Lines.Add('$Dir=Get-ChildItem');
  Memo1.Lines.Add('$Dir');

  FhPSWnd  := 0;
  FInitDir := ExpandFileName('.\');
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if CheckBox2.Checked then begin
    EnumWindows(@EnumWindowsHandleProc, LPARAM(@FhPSWnd));
  end;
  FhPSWnd := 0;
end;

//=============================================================================
//  R}h̎s
//  o͂̃_CNgMemo1
//  {vOPowerShell̃EBhENĂ鎞͂̃EBhE
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LSavePath    : string;
  LIndex       : Integer;
  LCmdRedirect : TplCommandRedirect;
  LCmdLine     : string;
  LProcessID   : Cardinal;
  LIsPSVisible : Boolean;
begin
  LIndex    := Pos('.PS1', UpperCase(Edit1.Text));
  LSavePath := Copy(Edit1.Text, 1, LIndex + 4);
  Memo1.Lines.SaveToFile(Trim(LSavePath));

  Memo2.Clear;
  Memo2.Update;

  if FPSExeFullPath = '' then begin
    Memo2.Lines.Add('PowerShell ܂ł');
  end else begin
    Memo2.Clear;
    LIsPSVisible:= IsWindowVisible(FhPSWnd);
    if LIsPSVisible then begin
      //Xbh̃vZXID擾
      GetWindowThreadProcessId(FhPSWnd, @LProcessID);

      //R\[̃XbhɃA^b`
      if AttachConsole(LProcessID) then begin
        //R}hs
        LCmdLine := ExpandFileName(Edit1.Text);
        SendCommandPrompt(LCmdLine);
        //FreeConsoleŃfA^b`Ă
        FreeConsole;
      end;
    end else begin
      LCmdRedirect  := TplCommandRedirect.Create;
      try
        Memo2.Clear;
        LCmdLine   := FPSExeFullPath + ' -ExecutionPolicy RemoteSigned -File '
                    + ExpandFileName(Edit1.Text);
        Memo2.Text := LCmdRedirect.GrabStdOutText(LCmdLine);
        if Memo1.Text = '' then begin
          Memo2.Lines.Add('R}h̎sɎsm܂');
        end;
      finally
        FreeAndNil(LCmdRedirect);
      end;
    end;
  end;
end;

//=============================================================================
//  XNvg̃R[hNA
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.SetFocus;
end;

//=============================================================================
//  Nbv{[h\t
//  \tJnʒu݂͌̃J[\ʒu
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
  Memo1.SetFocus;
end;

//-----------------------------------------------------------------------------
//  ShellExecuteExŎwt@Cs
//  ShellExcuteEx̎gpɂusesShellAPIKv
//-----------------------------------------------------------------------------
function RunExeFile(hWnd: HWND; AFile: String; AParameters: String;
   Verb: String): Cardinal;
var
  LInfo : TShellExecuteInfo;
  LRet  : Cardinal;
begin
  FillChar(LInfo, SizeOf(LInfo), 0);
  LInfo.cbSize := SizeOf(LInfo);
  LInfo.Wnd    := hWnd;

  LInfo.fMask  := SEE_MASK_FLAG_DDEWAIT
               or SEE_MASK_FLAG_NO_UI
               or SEE_MASK_NOCLOSEPROCESS;
  LInfo.lpVerb := PChar(Verb);

  LInfo.lpFile       := PChar(AFile);
  LInfo.lpParameters := PChar(AParameters);
  LInfo.nShow        := SW_SHOW;

  ShellExecuteEx(@LInfo);

  //ShellExecuteEx͐hInstApp33ȏ̒lԂ
  if LInfo.hInstApp >= 33 then begin
    //vZX܂ő҂
    repeat
      LRet := WaitForInputIdle(LInfo.hProcess, 50);
      Application.ProcessMessages;
      Sleep(10);
    until LRet <> WAIT_TIMEOUT;

    CloseHandle(LInfo.hProcess);
  end;

  Result := LInfo.hInstApp;
end;

//=============================================================================
//  PowerShell̃R\[EBhEN
//=============================================================================
procedure TForm1.Button4Click(Sender: TObject);
var
  LFilePath  : String;
  LParams    : String;
  LhInstance : Cardinal;
begin
  //Nt@C̃pX
  LFilePath := 'PowerShell.exe';
  //NAv̋NIvV
  LParams := '-noExit  -ExecutionPolicy RemoteSigned';

  LhInstance := RunExeFile(Handle, LFilePath, LParams, '');

  if LhInstance <= 32 then begin
    Windows.MessageBox(Handle, 'NɎs܂', 'G[', MB_ICONSTOP);
  end else begin
    while True do begin
      FhPSWnd := 0;
      EnumWindows(@EnumWindowsHandleProc, LPARAM(@FhPSWnd));
      if FhPSWnd > 0 then break;
      Application.ProcessMessages;
      Sleep(1);
    end;
  end;
end;

//=============================================================================
//  XNvgt@C̓ǂݍ
//=============================================================================
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  OpenDialog1.Filter     := 'XNvgt@C|*.ps1';
  OpenDialog1.InitialDir := FInitDir;
  if not OpenDialog1.Execute then exit;

  FInitDir :=  ExtractFileDir(OpenDialog1.FileName);
  Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
  Edit1.Text := OpenDialog1.FileName;
end;

//=============================================================================
//  TNkClipDetectorOnClipChangeCxg
//  Nbv{[h̊ĎCxg
//=============================================================================
procedure TForm1.NkClipDetector1ClipChange(Sender: TObject);
begin
  Button3.Enabled := Clipboard.HasFormat(CF_TEXT);
  if (Button3.Enabled) and (CheckBox1.Checked) then begin
    Memo1.Lines.Text := Trim(Clipboard.AsText);
  end;
end;

end.
